;;;==========================================
;;;  Stromoperationen 

(define (glattabb f s) (glaetten (abb f s)))
 
(define (abb f s)
  (let ((liste (force s)))
    (if (null? liste)
        '()
        (delay (cons (f (car liste)) 
                     (abb f (cdr liste)))))))
 
(define (glaetten s)
  (akk append-stroeme  '()  s))
 
(define (akk op e s)
  (let ((liste (force s)))
    (if (null? liste)
        e
        (op  (car liste)  
	     (delay (akk op e (cdr liste)))))))

(define (append-stroeme l1 s)
    (if (null? l1)
        (force s)
        (delay (cons (car l1) 
		     (append-stroeme  (cdr l1) s)))))
 
(define (take n l)
  (if (= n 0)
      '()
      (let ((liste (force l)))
        (cons (car liste) 
	      (take (- n 1) (cdr liste))))))

;;;=============================================
;;;   Erzeugung der Tripel

(define (groesser_2)
  (define (von n)
    (delay (cons n  (von (+ n 1)))))
  (von 2))

(define (summe_gleich_n n)
  (define (zaehle m)
    (if (= m n)
	'()
	(cons (list m (- n m))(zaehle (+ m 1)))))
  (zaehle 1))

(define paare
  (glattabb summe_gleich_n (groesser_2)))

(define (paar_tripel paar)
  (define (zaehle i j k)
    (if (<= (+ i j) k)
	'()
	(cons (list i j k) (zaehle i j (+ k 1)))))
  (zaehle (car paar) (cadr paar) 1))

(define tripel  (glattabb paar_tripel paare))

